/* gisicomm-1.0.vapi generated by valac 0.14.2, do not modify. */

namespace GIsiComm {
	[CCode (cheader_filename = "gisicomm.h")]
	public abstract class AbstractBaseClient {
		public GLib.SourceFunc cb;
		protected weak GIsi.Client client;
		public uint16 isiobj;
		public bool reachable;
		public AbstractBaseClient ();
		public uint8 align4 (uint8 size);
		protected abstract void onSubsystemIsReachable ();
		public void sendGenericRequest (uint8[] req, GIsiComm.ByteArrayResultFunc cb);
		public async void waitUntilSubsystemIsOnline ();
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class Call : GIsiComm.AbstractBaseClient {
		public struct ISI_CallStatus {
			public uint8 id;
			public GIsiClient.Call.Status status;
			public uint8 ntype;
			public string number;
		}
		public Call (GIsi.Modem modem);
		public void answerVoiceCall (uint8 callid, GIsiComm.VoidResultFunc cb);
		public void controlVoiceCall (uint8 callid, GIsiClient.Call.Operation operation, uint8 param, GIsiComm.VoidResultFunc cb);
		public void initiateVoiceCall (string number, uint8 ntype, GIsiClient.Call.PresentationType presentation, GIsiComm.IntResultFunc cb);
		protected override void onSubsystemIsReachable ();
		public void releaseVoiceCall (uint8 callid, GIsiClient.Call.CauseType causeType, GIsiClient.Call.IsiCause causeValue, GIsiComm.VoidResultFunc cb);
		public void sendTonesOnVoiceCall (uint8 callid, string tones, GIsiComm.VoidResultFunc cb);
		public signal void statusChanged (GIsiComm.Call.ISI_CallStatus status);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class EpocInfo {
		public EpocInfo (GIsi.Modem modem);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class GPDS : GIsiComm.AbstractBaseClient {
		public GPDS (GIsi.Modem modem);
		public async void activate (string apn, string? user, string? pw, GIsiComm.VoidResultFunc cb);
		public async void deactivate ();
		protected override void onSubsystemIsReachable ();
		public signal void contextActivated (string iface, string ip, string dns1, string dns2);
		public signal void contextDeactivated ();
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class GPDSHelper {
		public GLib.SourceFunc cb;
		public GIsiComm.GPDS instance;
		public GPDSHelper (GIsiComm.GPDS instance, GLib.SourceFunc cb);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class GSS : GIsiComm.AbstractBaseClient {
		public GSS (GIsi.Modem modem);
		protected override void onSubsystemIsReachable ();
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class MTC : GIsiComm.AbstractBaseClient {
		public delegate void IsiCauseResultFunc (GIsiComm.ErrorCode error, GIsiClient.MTC.IsiCause cause);
		protected GIsiClient.MTC ll;
		public GIsiClient.MTC.ModemState state;
		public MTC (GIsi.Modem modem);
		protected override void onSubsystemIsReachable ();
		public void readState (GIsiComm.MtcStatesResultFunc cb);
		public void setPower (bool on, GIsiComm.MTC.IsiCauseResultFunc cb);
		public void setState (bool on, bool online, GIsiComm.IntResultFunc cb);
		public void startupSynq (GIsiComm.VoidResultFunc cb);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class ModemAccess {
		public GIsiComm.Call call;
		public GIsiComm.EpocInfo epoc;
		public GIsiComm.GPDS gpds;
		public GIsiComm.GSS gss;
		public GIsiComm.PhoneInfo info;
		public GIsi.Modem m;
		public GIsiComm.MTC mtc;
		public GIsiComm.Network net;
		protected weak GIsi.PhonetNetlink netlink;
		protected GIsiComm.OnlineStatus online;
		public GIsiComm.SIM sim;
		public GIsiComm.SIMAuth simauth;
		public GIsiComm.SMS sms;
		public GIsiComm.SS ss;
		public GIsiClient.MTC.ModemState state;
		public ModemAccess (string iface);
		public async bool connect ();
		public async void disconnect ();
		public async bool launch ();
		public async bool poweron ();
		public async bool startup ();
		public signal void netlinkChanged (bool online);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class Network : GIsiComm.AbstractBaseClient {
		public struct ISI_Provider {
			public GIsiClient.Network.OperatorStatus status;
			public string name;
			public string mcc;
			public string mnc;
			public int technology;
		}
		public struct ISI_RegStatus {
			public GIsiClient.Network.RegistrationStatus status;
			public GIsiClient.Network.OperatorSelectMode mode;
			public string network;
			public string name;
			public string lac;
			public string cid;
			public string mcc;
			public string mnc;
			public uint band;
			public bool egprs;
			public bool hsdpa;
			public bool hsupa;
		}
		public struct ISI_Time {
			public uint8 year;
			public uint8 mon;
			public uint8 mday;
			public uint8 hour;
			public uint8 min;
			public uint8 sec;
			public uint8 utc;
			public uint8 dst;
		}
		public Network (GIsi.Modem modem);
		public void listProviders (owned GIsiComm.IsiProviderArrayResultFunc cb);
		protected override void onSubsystemIsReachable ();
		public void queryRat (owned GIsiComm.IntResultFunc cb);
		public void queryStatus (owned GIsiComm.IsiRegStatusResultFunc cb);
		public void queryStrength (owned GIsiComm.IntResultFunc cb);
		public void registerAutomatic (bool force, owned GIsiComm.VoidResultFunc cb);
		public void registerManual (string mcc, string mnc, owned GIsiComm.VoidResultFunc cb);
		public signal void registrationStatus (GIsiComm.Network.ISI_RegStatus status);
		public signal void signalStrength (uint8 rssi);
		public signal void timeInfo (GLib.Time time);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class PhoneInfo : GIsiComm.AbstractBaseClient {
		protected GIsiClient.PhoneInfo ll;
		public PhoneInfo (GIsi.Modem modem);
		protected override void onSubsystemIsReachable ();
		public void readManufacturer (owned GIsiComm.StringResultFunc cb);
		public void readModel (owned GIsiComm.StringResultFunc cb);
		public void readSerial (owned GIsiComm.StringResultFunc cb);
		public void readVersion (owned GIsiComm.StringResultFunc cb);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class SIM : GIsiComm.AbstractBaseClient {
		public SIM (GIsi.Modem modem);
		protected override void onSubsystemIsReachable ();
		public void readHPLMN (owned GIsiComm.StringResultFunc cb);
		public void readIMSI (owned GIsiComm.StringResultFunc cb);
		public void readSPN (owned GIsiComm.StringResultFunc cb);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class SIMAuth : GIsiComm.AbstractBaseClient {
		protected GIsiClient.SIMAuth ll;
		public SIMAuth (GIsi.Modem modem);
		public async void changePin (string oldpin, string newpin, owned GIsiComm.VoidResultFunc cb);
		protected override void onSubsystemIsReachable ();
		public void queryStatus (owned GIsiComm.IntResultFunc cb);
		public void sendPin (string pin, owned GIsiComm.IntResultFunc cb);
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class SMS : GIsiComm.AbstractBaseClient {
		public SMS (GIsi.Modem modem);
		protected override void onSubsystemIsReachable ();
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public class SS : GIsiComm.AbstractBaseClient {
		public SS (GIsi.Modem modem);
		protected override void onSubsystemIsReachable ();
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public enum ErrorCode {
		OK,
		INVALID_FORMAT
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public enum OnlineStatus {
		UNKNOWN,
		NO,
		YES
	}
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void BoolResultFunc (GIsiComm.ErrorCode error, bool yesOrNo);
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void ByteArrayResultFunc (GIsiComm.ErrorCode code, uint8[] array);
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void IntResultFunc (GIsiComm.ErrorCode error, int result);
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void IsiProviderArrayResultFunc (GIsiComm.ErrorCode error, GIsiComm.Network.ISI_Provider[] providers);
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void IsiRegStatusResultFunc (GIsiComm.ErrorCode error, GIsiComm.Network.ISI_RegStatus? status);
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void MtcStatesResultFunc (GIsiComm.ErrorCode error, GIsiClient.MTC.ModemState current, GIsiClient.MTC.ModemState target);
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void StringResultFunc (GIsiComm.ErrorCode error, string? result);
	[CCode (cheader_filename = "gisicomm.h")]
	public delegate void VoidResultFunc (GIsiComm.ErrorCode error);
}
